/*

                WetherMeter

                Cۏ̎WƋL^

	i2cTinyRtc.h

	IICڑRTCW[Rg[B

	Copyrights 2010,  Yoshi Hiroshi.

 */
#include <avr/io.h>

#define RTC_ADDRESS             0x51

#define GET_DIGIT(hex)          (((hex) >> 4) * 10 + ((hex) & 0x0F))
#define GET_HEX_DIGIT(dec)      ((((dec) / 10) << 4) | ((dec) % 10))

unsigned char* getRtcBuff();
void rtcDateRead();
void rtcDateWrite(unsigned char yy, unsigned char mm, unsigned char dd);
void rtcTimeWrite(unsigned char hh, unsigned char min, unsigned char ss);



void rtcInit();
void rtcSendStartCondition();
void rtcSendStopCondition();
unsigned char rtcWriteData(unsigned char val);
unsigned char rtcWrite(unsigned char slaveAdrs, unsigned char control, unsigned char* data, unsigned char len);
unsigned char rtcReadData(unsigned char ack);
unsigned char rtcRead(unsigned char slaveAdrs, unsigned char control, unsigned char* data, unsigned char len);

//--- I2C value
#define RTC_REQUEST_WRITE		0
#define RTC_REQUEST_READ		1
//--- Inernal Value
#define RTC_DELAY_SHORT				asm volatile("nop\n\tnop")
#define RTC_DELAY_LONG				asm volatile("nop\n\tnop\n\tnop")

// Device Dependent Configuration

//--- Bit Assignment
#define RTC_SCL					5
#define RTC_SDA					4
//--- Register Assignment
#define RTC_SCL_PORT		    PORTC
#define RTC_SCL_DDR				DDRC
#define RTC_SCL_PIN				PINC
#define RTC_SDA_PORT			PORTC
#define RTC_SDA_DDR				DDRC
#define RTC_SDA_PIN				PINC

//--- SCL MACRO Assignment
#define RTC_SCL_AS_INPUT		RTC_SCL_DDR &= ~_BV(RTC_SCL)
#define RTC_SCL_AS_OUTPUT		RTC_SCL_DDR |= _BV(RTC_SCL)
#define RTC_SCL_FREE			RTC_SCL_PORT |= _BV(RTC_SCL); RTC_SCL_AS_INPUT
#define RTC_SCL_SET_LOW			RTC_SCL_AS_OUTPUT; RTC_SCL_PORT &= ~_BV(RTC_SCL)
#define RTC_SCL_CURR_VAL		(RTC_SCL_PIN  & _BV(RTC_SCL))
//--- SDA MACRO Assignment
#define RTC_SDA_AS_INPUT		RTC_SDA_DDR &= ~_BV(RTC_SDA)
#define RTC_SDA_AS_OUTPUT		RTC_SDA_DDR |= _BV(RTC_SDA)
#define RTC_SDA_FREE			RTC_SDA_PORT |= _BV(RTC_SDA); RTC_SDA_AS_INPUT
#define RTC_SDA_SET_LOW			RTC_SDA_AS_OUTPUT; RTC_SDA_PORT &= ~_BV(RTC_SDA)
#define RTC_SDA_CURR_VAL		(RTC_SDA_PIN  & _BV(RTC_SDA))

