/*

                WetherMeter

                Cۏ̎WƋL^

	i2cTinySht.c

	^IICڑ̎xZT[Rg[B

	Copyrights 2010,  Yoshi Hiroshi.

 */

#include "i2cTinySht.h"


//------------------------------
void shtInit()
{
	SHT_SDA_FREE;
	SHT_SCL_SET_LOW;
}

//------------------------------
void shtSendStartCondition(unsigned char resetReq)
{
    if(resetReq) {          // Reset Interface
        for(char count = 0; count < 9; count++)
        {
    	    SHT_SCL_SET_LOW;		// low SCL line
    	    SHT_SCL_FREE;			// free SCL line
        }
    	SHT_SCL_SET_LOW;		    // low SCL line
    }
	SHT_SCL_FREE;			// free SCL line
	SHT_SDA_SET_LOW;		// low SDA line
	SHT_SCL_SET_LOW;		// low SCL line
	SHT_SCL_FREE;			// free SCL line
	SHT_SDA_FREE;			// free SDA line
	SHT_SCL_SET_LOW;		// low  SCL line
}

//------------------------------
unsigned char shtWriteData(unsigned char val)
{
	unsigned char result;
	for(unsigned char count = 0; count < 8; count++)
    {
        if(val & 0x80) {
        	SHT_SDA_FREE;			// send 1
        } else {
        	SHT_SDA_SET_LOW;	    // send 0
        }
		SHT_SCL_FREE;               // toggle SCL to high(free)
		while( SHT_SCL_CURR_VAL == 0 );
		SHT_SCL_SET_LOW;            // toggle SCL to low
        val = val << 1;
	}
    SHT_SDA_FREE;
    SHT_SCL_FREE;               // toggle SCL to high(free)
    result = SHT_SDA_CURR_VAL;
	SHT_SCL_SET_LOW;            // toggle SCL to low
    if(result == 0) {
        while(SHT_SDA_CURR_VAL == 0);
    }
	return (result == 0);
}

//------------------------------
unsigned char shtReadData(unsigned char ack)
{
	unsigned char result = 0;
	for(unsigned char count = 0; count < 8; count++)
    {
        result = result << 1;
		SHT_SCL_FREE;               // toggle SCL to high(free)
        result |= SHT_SDA_CURR_VAL? 1:0;
		SHT_SCL_SET_LOW;            // toggle SCL to low
	}
    if(ack) {
        SHT_SDA_FREE;               // set ack bit
    } else {
        SHT_SDA_SET_LOW;            // set ack bit
    }
    SHT_SCL_FREE;               // toggle SCL to high(free) // send ack bit
	SHT_SCL_SET_LOW;            // toggle SCL to low
    SHT_SDA_FREE;               // SDA bit FREE
	return result;
}

//------------------------------
int shtGetHumidityRead()
{
    int result = 0;
// o Send start
	shtSendStartCondition(1);
// o Send Slave address & read/write flga
	if(shtWriteData(SHT_COMAND_GET_HUMIDITY))
	{
// wait for data ready
        while(SHT_SDA_CURR_VAL != 0);
// o Read data
        result = (shtReadData(0) & 0x0F) << 8;
        result |= (shtReadData(1) & 0xFF);
	}
//
	return result;
}

void shtStartMeassure()
{
// o Send start
	shtSendStartCondition(0);
// o Send Slave address & read/write flga
	shtWriteData(SHT_COMAND_GET_HUMIDITY);
}

int shtReadWord()
{
    int result;
    result = shtReadData(0) << 8;
    result |= shtReadData(1);
    return result;
}
