/*
                WetherMeter

                Cۏ̎WƋL^

			Copyrights 2010,  Yoshi Hiroshi

*/

#include <avr/io.h>
#include "uart.h"

/*
 *      Console IO
 */

FILE uart = FDEV_SETUP_STREAM(uartPutChar, uartGetChar, _FDEV_SETUP_RW);

//*********************************************************************
//
//
char txBuff[TX_BUFSIZE];
char * txBufPtrIn = txBuff;
char * txBufPtrOut = txBuff;
char rxBuff[RX_BUFSIZE];
char * rxBufPtrIn = rxBuff;
char * rxBufPtrOut = rxBuff;


/**********************************************************************
 *
 ---------------------------------------------------------------------*/
void initUART()
{
// USART
    UCSR0C = _BV(UCSZ01) | _BV(UCSZ00);
//    UCSR0B = _BV(RXEN0) | _BV(TXEN0) | _BV(UDRIE0);
    UCSR0B = _BV(RXEN0) | _BV(TXEN0);
    UCSR0A = _BV(U2X0);
    UBRR0 = 12;     // 9600 baud 
// stdio
    stdout = stdin = &uart;
    stderr = &uart;
}

/**********************************************************************
 *
 ---------------------------------------------------------------------*/
void uartPutTxBuff(char c)
{
    char * nextPtr = txBufPtrIn;
    nextPtr++;
    if(nextPtr >= &txBuff[TX_BUFSIZE])
    {
        nextPtr = txBuff;
    }
    if(nextPtr != txBufPtrOut)
    {
        *txBufPtrIn = c;
        txBufPtrIn = nextPtr;
    }
}

/**********************************************************************
 *
 ---------------------------------------------------------------------*/
int uartGetTxBuff()
{
    char c;
    if(txBufPtrIn == txBufPtrOut) return 0;
    c = *txBufPtrOut++;
    if(txBufPtrOut >= &txBuff[TX_BUFSIZE])
    {
        txBufPtrOut = txBuff;
    }
    return c;
}

/**********************************************************************
 *
 ---------------------------------------------------------------------*/
char uartCheckAndSend()
{
    char c = 0;
    if(UCSR0A & _BV(UDRE0))
    {
        if(txBufPtrIn != txBufPtrOut)
        {
            if((c = uartGetTxBuff()) != 0)
            {
                UDR0 = c;
            }
        }
    }
    return c;
}

/**********************************************************************
 *
 ---------------------------------------------------------------------*/
void uartPutRxBuff(char c)
{
    char * nextPtr = rxBufPtrIn;
    nextPtr++;
    if(nextPtr >= &rxBuff[RX_BUFSIZE])
    {
        nextPtr = rxBuff;
    }
    if(nextPtr != rxBufPtrOut)
    {
        *rxBufPtrIn = c;
        rxBufPtrIn = nextPtr;
    }
}

/**********************************************************************
 *
 ---------------------------------------------------------------------*/
int uartGetRxBuff()
{
    char c;
    if(rxBufPtrIn == rxBufPtrOut) return 0;
    c = *rxBufPtrOut++;
    if(rxBufPtrOut >= &rxBuff[RX_BUFSIZE])
    {
        rxBufPtrOut = rxBuff;
    }
    return c;
}

/**********************************************************************
 *
 ---------------------------------------------------------------------*/
int uartCheckAndRecv()
{
    if(UCSR0A & _BV(RXC0))
    {
        uartPutRxBuff(UDR0);
    }
	if (UCSR0A & _BV(FE0))
	  return _FDEV_EOF;
	if (UCSR0A & _BV(DOR0))
	  return _FDEV_ERR;
    return (rxBufPtrIn != rxBufPtrOut);
}

/**********************************************************************
 *
 *          Standart I/O Interface                  uartPutChar
 *
 *          Xg[֕1o͂
 *
 **********************************************************************/
int uartPutChar(char c, FILE *stream)
{
    if (c == '\n')
        uartPutTxBuff('\r');
    uartPutTxBuff(c);
    return 0;
}

/**********************************************************************
 *
 *          Standart I/O Interface                  uartGetChar
 *
 *          Xg[當1͂
 *
 **********************************************************************/
int uartGetChar(FILE *stream)
{
  return uartGetRxBuff();
}



